<?php
/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package charitable_funds
 */

function charitable_funds_body_classes( $charitable_funds_classes ) {
	// Adds a class of hfeed to non-singular pages.
	if ( ! is_singular() ) {
		$charitable_funds_classes[] = 'hfeed';
	}

	// Adds a class of no-sidebar when there is no sidebar present.
	if ( ! is_active_sidebar( 'sidebar-1' ) ) {
		$charitable_funds_classes[] = 'no-sidebar';
	}

	$charitable_funds_classes[] = charitable_funds_sidebar_layout();

	return $charitable_funds_classes;
}
add_filter( 'body_class', 'charitable_funds_body_classes' );

/**
 * Add a pingback url auto-discovery header for single posts, pages, or attachments.
 */
function charitable_funds_pingback_header() {
	if ( is_singular() && pings_open() ) {
		printf( '<link rel="pingback" href="%s">', esc_url( get_bloginfo( 'pingback_url' ) ) );
	}
}
add_action( 'wp_head', 'charitable_funds_pingback_header' );


/**
 * Get all posts for customizer Post content type.
 */
function charitable_funds_get_post_choices() {
	$charitable_funds_choices = array( '' => esc_html__( '--Select--', 'charitable-funds' ) );
	$charitable_funds_args    = array( 'numberposts' => -1 );
	$charitable_funds_posts   = get_posts( $charitable_funds_args );

	foreach ( $charitable_funds_posts as $charitable_funds_post ) {
		$charitable_funds_id             = $charitable_funds_post->ID;
		$charitable_funds_title          = $charitable_funds_post->post_title;
		$charitable_funds_choices[ $charitable_funds_id ] = $charitable_funds_title;
	}

	return $charitable_funds_choices;
}

/**
 * Get all pages for customizer Page content type.
 */
function charitable_funds_get_page_choices() {
	$charitable_funds_choices = array( '' => esc_html__( '--Select--', 'charitable-funds' ) );
	$charitable_funds_pages   = get_pages();

	foreach ( $charitable_funds_pages as $charitable_funds_page ) {
		$charitable_funds_choices[ $charitable_funds_page->ID ] = $charitable_funds_page->post_title;
	}

	return $charitable_funds_choices;
}

/**
 * Get all categories for customizer Category content type.
 */
function charitable_funds_get_post_cat_choices() {
	$charitable_funds_choices = array( '' => esc_html__( '--Select--', 'charitable-funds' ) );
	$charitable_funds_cats    = get_categories();

	foreach ( $charitable_funds_cats as $charitable_funds_cat ) {
		$charitable_funds_choices[ $charitable_funds_cat->term_id ] = $charitable_funds_cat->name;
	}

	return $charitable_funds_choices;
}

/**
 * Get all donation forms for customizer form content type.
 */
function charitable_funds_get_post_donation_form_choices() {
	$charitable_funds_choices = array( '' => esc_html__( '--Select--', 'charitable-funds' ) );
	$charitable_funds_posts   = get_posts(
		array(
			'post_type'   => 'give_forms',
			'numberposts' => -1,
		)
	);
	foreach ( $charitable_funds_posts as $charitable_funds_post ) {
		$charitable_funds_choices[ $charitable_funds_post->ID ] = $charitable_funds_post->post_title;
	}
	return $charitable_funds_choices;
}

if ( ! function_exists( 'charitable_funds_excerpt_length' ) ) :
	/**
	 * Excerpt length.
	 */
	function charitable_funds_excerpt_length( $charitable_funds_length ) {
		if ( is_admin() ) {
			return $charitable_funds_length;
		}

		return get_theme_mod( 'charitable_funds_excerpt_length', 20 );
	}
endif;
add_filter( 'excerpt_length', 'charitable_funds_excerpt_length', 999 );

if ( ! function_exists( 'charitable_funds_excerpt_more' ) ) :
	/**
	 * Excerpt more.
	 */
	function charitable_funds_excerpt_more( $charitable_funds_more ) {
		if ( is_admin() ) {
			return $charitable_funds_more;
		}

		return '&hellip;';
	}
endif;
add_filter( 'excerpt_more', 'charitable_funds_excerpt_more' );

if ( ! function_exists( 'charitable_funds_sidebar_layout' ) ) {
	/**
	 * Get sidebar layout.
	 */
	function charitable_funds_sidebar_layout() {
		$charitable_funds_sidebar_position      = get_theme_mod( 'charitable_funds_sidebar_position', 'right-sidebar' );
		$charitable_funds_sidebar_position_post = get_theme_mod( 'charitable_funds_post_sidebar_position', 'right-sidebar' );
		$charitable_funds_sidebar_position_page = get_theme_mod( 'charitable_funds_page_sidebar_position', 'right-sidebar' );

		if ( is_home() ) {
			$charitable_funds_sidebar_position = $charitable_funds_sidebar_position_post;
		} elseif ( is_page() ) {
			$charitable_funds_sidebar_position = $charitable_funds_sidebar_position_page;
		}

		return $charitable_funds_sidebar_position;
	}
}

if ( ! function_exists( 'charitable_funds_is_sidebar_enabled' ) ) {
	/**
	 * Check if sidebar is enabled.
	 */
	function charitable_funds_is_sidebar_enabled() {
		$charitable_funds_sidebar_position      = get_theme_mod( 'charitable_funds_sidebar_position', 'right-sidebar' );
		$charitable_funds_sidebar_position_post = get_theme_mod( 'charitable_funds_post_sidebar_position', 'right-sidebar' );
		$charitable_funds_sidebar_position_page = get_theme_mod( 'charitable_funds_page_sidebar_position', 'right-sidebar' );

		$charitable_funds_sidebar_enabled = true;
		if ( is_single() || is_archive() || is_search() ) {
			if ( 'no-sidebar' === $charitable_funds_sidebar_position ) {
				$charitable_funds_sidebar_enabled = false;
			}
		} elseif ( is_home() ) {
			if ( 'no-sidebar' === $charitable_funds_sidebar_position || 'no-sidebar' === $charitable_funds_sidebar_position_post ) {
				$charitable_funds_sidebar_enabled = false;
			}
		} elseif ( is_page() ) {
			if ( 'no-sidebar' === $charitable_funds_sidebar_position || 'no-sidebar' === $charitable_funds_sidebar_position_page ) {
				$charitable_funds_sidebar_enabled = false;
			}
		}
		return $charitable_funds_sidebar_enabled;
	}
}

if ( ! function_exists( 'charitable_funds_get_homepage_sections ' ) ) {
	/**
	 * Returns homepage sections.
	 */
	function charitable_funds_get_homepage_sections() {
		$charitable_funds_sections = array(
			'banner'  => esc_html__( 'Banner Section', 'charitable-funds' ),
			'event' => esc_html__( 'Event Section', 'charitable-funds' ),
		);
		return $charitable_funds_sections;
	}
}

/**
 * Renders customizer section link
 */
function charitable_funds_section_link( $charitable_funds_section_id ) {
	$charitable_funds_section_name      = str_replace( 'charitable_funds_', ' ', $charitable_funds_section_id );
	$charitable_funds_section_name      = str_replace( '_', ' ', $charitable_funds_section_name );
	$charitable_funds_starting_notation = '#';
	?>
	<span class="section-link">
		<span class="section-link-title"><?php echo esc_html( $charitable_funds_section_name ); ?></span>
	</span>
	<style type="text/css">
		<?php echo $charitable_funds_starting_notation . $charitable_funds_section_id; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>:hover .section-link {
			visibility: visible;
		}
	</style>
	<?php
}

/**
 * Adds customizer section link css
 */
function charitable_funds_section_link_css() {
	if ( is_customize_preview() ) {
		?>
		<style type="text/css">
			.section-link {
				visibility: hidden;
				background-color: black;
				position: relative;
				top: 80px;
				z-index: 99;
				left: 40px;
				color: #fff;
				text-align: center;
				font-size: 20px;
				border-radius: 10px;
				padding: 20px 10px;
				text-transform: capitalize;
			}

			.section-link-title {
				padding: 0 10px;
			}

			.banner-section {
				position: relative;
			}

			.banner-section .section-link {
				position: absolute;
				top: 100px;
			}
		</style>
		<?php
	}
}
add_action( 'wp_head', 'charitable_funds_section_link_css' );

/**
 * Breadcrumb.
 */
function charitable_funds_breadcrumb( $charitable_funds_args = array() ) {
	if ( ! get_theme_mod( 'charitable_funds_enable_breadcrumb', true ) ) {
		return;
	}

	$charitable_funds_args = array(
		'show_on_front' => false,
		'show_title'    => true,
		'show_browse'   => false,
	);
	breadcrumb_trail( $charitable_funds_args );
}
add_action( 'charitable_funds_breadcrumb', 'charitable_funds_breadcrumb', 10 );

/**
 * Add separator for breadcrumb trail.
 */
function charitable_funds_breadcrumb_trail_print_styles() {
	$charitable_funds_breadcrumb_separator = get_theme_mod( 'charitable_funds_breadcrumb_separator', '/' );

	$charitable_funds_style = '
		.trail-items li::after {
			content: "' . $charitable_funds_breadcrumb_separator . '";
		}'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

	$charitable_funds_style = apply_filters( 'charitable_funds_breadcrumb_trail_inline_style', trim( str_replace( array( "\r", "\n", "\t", '  ' ), '', $charitable_funds_style ) ) );

	if ( $charitable_funds_style ) {
		echo "\n" . '<style type="text/css" id="breadcrumb-trail-css">' . $charitable_funds_style . '</style>' . "\n"; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
}
add_action( 'wp_head', 'charitable_funds_breadcrumb_trail_print_styles' );

/**
 * Pagination for archive.
 */
function charitable_funds_render_posts_pagination() {
	$charitable_funds_is_pagination_enabled = get_theme_mod( 'charitable_funds_enable_pagination', true );
	if ( $charitable_funds_is_pagination_enabled ) {
		$charitable_funds_pagination_type = get_theme_mod( 'charitable_funds_pagination_type', 'default' );
		if ( 'default' === $charitable_funds_pagination_type ) :
			the_posts_navigation();
		else :
			the_posts_pagination();
		endif;
	}
}
add_action( 'charitable_funds_posts_pagination', 'charitable_funds_render_posts_pagination', 10 );

/**
 * Pagination for single post.
 */
function charitable_funds_render_post_navigation() {
	the_post_navigation(
		array(
			'prev_text' => '<span>&#10229;</span> <span class="nav-title">%title</span>',
			'next_text' => '<span class="nav-title">%title</span> <span>&#10230;</span>',
		)
	);
}
add_action( 'charitable_funds_post_navigation', 'charitable_funds_render_post_navigation' );

/**
 * Adds footer copyright text.
 */
function charitable_funds_output_footer_copyright_content() {
    $charitable_funds_theme_data = wp_get_theme();
    $charitable_funds_copyright_text = get_theme_mod('charitable_funds_footer_copyright_text');

	if (!empty($charitable_funds_copyright_text)) {
        $charitable_funds_text = $charitable_funds_copyright_text;
    } else {

		$charitable_funds_default_text = '<a href="'. esc_url(__('https://asterthemes.com/products/charitable-funds','charitable-funds')) . '" target="_blank"> ' . esc_html($charitable_funds_theme_data->get('Name')) . '</a>' . '&nbsp;' . esc_html__('by', 'charitable-funds') . '&nbsp;<a target="_blank" href="' . esc_url($charitable_funds_theme_data->get('AuthorURI')) . '">' . esc_html(ucwords($charitable_funds_theme_data->get('Author'))) . '</a>';
		/* translators: %s: WordPress.org URL */
        $charitable_funds_default_text .= sprintf(esc_html__(' | Powered by %s', 'charitable-funds'), '<a href="' . esc_url(__('https://wordpress.org/', 'charitable-funds')) . '" target="_blank">WordPress</a>. ');

        $charitable_funds_text = $charitable_funds_default_text;

    }
    ?>
    <span><?php echo wp_kses_post($charitable_funds_text); ?></span>
    <?php
}
add_action('charitable_funds_footer_copyright', 'charitable_funds_output_footer_copyright_content');

/* Footer Social Icons */ 
function charitable_funds_footer_social_links() {

    if ( get_theme_mod('charitable_funds_enable_footer_icon_section', true) ) {

            ?>
            <div class="socialicons">
				<div class="asterthemes-wrapper">
					<?php if ( get_theme_mod('charitable_funds_footer_facebook_link', 'https://www.facebook.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('charitable_funds_footer_facebook_link', 'https://www.facebook.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('charitable_funds_facebook_icon', 'fab fa-facebook-f')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Facebook', 'charitable-funds'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('charitable_funds_footer_twitter_link', 'https://x.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('charitable_funds_footer_twitter_link', 'https://x.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('charitable_funds_twitter_icon', 'fab fa-twitter')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Twitter', 'charitable-funds'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('charitable_funds_footer_instagram_link', 'https://www.instagram.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('charitable_funds_footer_instagram_link', 'https://www.instagram.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('charitable_funds_instagram_icon', 'fab fa-instagram')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Instagram', 'charitable-funds'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('charitable_funds_footer_linkedin_link', 'https://in.linkedin.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('charitable_funds_footer_linkedin_link', 'https://in.linkedin.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('charitable_funds_linkedin_icon', 'fab fa-linkedin')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Linkedin', 'charitable-funds'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('charitable_funds_footer_youtube_link', 'https://www.youtube.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('charitable_funds_footer_youtube_link', 'https://www.youtube.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('charitable_funds_youtube_icon', 'fab fa-youtube')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Youtube', 'charitable-funds'); ?></span>
						</a>
					<?php } ?>
				</div>
            </div>
            <?php
    }
}
add_action('wp_footer', 'charitable_funds_footer_social_links');

if ( ! function_exists( 'charitable_funds_footer_widget' ) ) :
	function charitable_funds_footer_widget() {
		$charitable_funds_footer_widget_column = get_theme_mod('charitable_funds_footer_widget_column','4');

		$charitable_funds_column_class = '';
		if ($charitable_funds_footer_widget_column == '1') {
			$charitable_funds_column_class = 'one-column';
		} elseif ($charitable_funds_footer_widget_column == '2') {
			$charitable_funds_column_class = 'two-columns';
		} elseif ($charitable_funds_footer_widget_column == '3') {
			$charitable_funds_column_class = 'three-columns';
		} else {
			$charitable_funds_column_class = 'four-columns';
		}
	
		if($charitable_funds_footer_widget_column !== ''): 
		?>
		<div class="dt_footer-widgets <?php echo esc_attr($charitable_funds_column_class); ?> wow bounceInUp delay-1000" data-wow-duration="2s">
			<div class="footer-widgets-column">
				<?php
				$footer_widgets_active = false;

				// Loop to check if any footer widget is active
				for ($charitable_funds_i = 1; $charitable_funds_i <= $charitable_funds_footer_widget_column; $charitable_funds_i++) {
					if (is_active_sidebar('footer-widget-' . $charitable_funds_i)) {
						$footer_widgets_active = true;
						break;
					}
				}

				if ($footer_widgets_active) {
					// Display active footer widgets
					for ($charitable_funds_i = 1; $charitable_funds_i <= $charitable_funds_footer_widget_column; $charitable_funds_i++) {
						if (is_active_sidebar('footer-widget-' . $charitable_funds_i)) : ?>
							<div class="footer-one-column">
								<?php dynamic_sidebar('footer-widget-' . $charitable_funds_i); ?>
							</div>
						<?php endif;
					}
				} else {
				?>
				<div class="footer-one-column default-widgets">
					<aside id="search-2" class="widget widget_search default_footer_search">
						<div class="widget-header">
							<h4 class="widget-title"><?php esc_html_e('Search Here', 'charitable-funds'); ?></h4>
						</div>
						<?php get_search_form(); ?>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-posts-2" class="widget widget_recent_entries">
						<h2 class="widget-title"><?php esc_html_e('Recent Posts', 'charitable-funds'); ?></h2>
						<ul>
							<?php
							$recent_posts = wp_get_recent_posts(array(
								'numberposts' => 5,
								'post_status' => 'publish',
							));
							foreach ($recent_posts as $post) {
								echo '<li><a href="' . esc_url(get_permalink($post['ID'])) . '">' . esc_html($post['post_title']) . '</a></li>';
							}
							wp_reset_query();
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-comments-2" class="widget widget_recent_comments">
						<h2 class="widget-title"><?php esc_html_e('Recent Comments', 'charitable-funds'); ?></h2>
						<ul>
							<?php
							$recent_comments = get_comments(array(
								'number' => 5,
								'status' => 'approve',
							));
							foreach ($recent_comments as $comment) {
								echo '<li><a href="' . esc_url(get_comment_link($comment)) . '">' .
									/* translators: %s: details. */
									sprintf(esc_html__('Comment on %s', 'charitable-funds'), get_the_title($comment->comment_post_ID)) .
									'</a></li>';
							}
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="categories" class="widget py-3" role="complementary" aria-label="<?php esc_attr_e('footer1', 'charitable-funds'); ?>">
                        <h3 class="widget-title"><?php esc_html_e('Categories', 'charitable-funds'); ?></h3>
                        <ul>
                            <?php wp_list_categories('title_li='); ?>
                        </ul>
                    </aside>
				</div>
			</div>
			<?php } ?>
		</div>
		<?php
		endif;
	}
	endif;
add_action( 'charitable_funds_footer_widget', 'charitable_funds_footer_widget' );


function charitable_funds_footer_text_transform_css() {
    $charitable_funds_footer_text_transform = get_theme_mod('footer_text_transform', 'none');
    ?>
    <style type="text/css">
        .site-footer h4,footer#colophon h2.wp-block-heading,footer#colophon .widgettitle,footer#colophon .widget-title {
            text-transform: <?php echo esc_html($charitable_funds_footer_text_transform); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'charitable_funds_footer_text_transform_css');

/**
 * GET START FUNCTION
 */

 function charitable_funds_getpage_css($hook) {
	wp_enqueue_script( 'charitable-funds-admin-script', get_template_directory_uri() . '/resource/js/charitable-funds-admin-notice-script.js', array( 'jquery' ) );
    wp_localize_script( 'charitable-funds-admin-script', 'charitable_funds_ajax_object',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
    );
    wp_enqueue_style( 'charitable-funds-notice-style', get_template_directory_uri() . '/resource/css/notice.css' );
}

add_action( 'admin_enqueue_scripts', 'charitable_funds_getpage_css' );

add_action('wp_ajax_charitable_funds_dismissable_notice', 'charitable_funds_dismissable_notice');
function charitable_funds_switch_theme() {
    delete_user_meta(get_current_user_id(), 'charitable_funds_dismissable_notice');
}
add_action('after_switch_theme', 'charitable_funds_switch_theme');
function charitable_funds_dismissable_notice() {
    update_user_meta(get_current_user_id(), 'charitable_funds_dismissable_notice', true);
    die();
}

function charitable_funds_deprecated_hook_admin_notice() {
    global $pagenow;
    
    // Check if the current page is the one where you don't want the notice to appear
    if ( $pagenow === 'themes.php' && isset( $_GET['page'] ) && $_GET['page'] === 'charitable-funds-getting-started' ) {
        return;
    }

    $dismissed = get_user_meta( get_current_user_id(), 'charitable_funds_dismissable_notice', true );
    if ( !$dismissed) { ?>
        <div class="getstrat updated notice notice-success is-dismissible notice-get-started-class">
            <div class="at-admin-content" >
                <h2><?php esc_html_e('Welcome to Charitable Funds', 'charitable-funds'); ?></h2>
                <p><?php _e('Explore the features of our Pro Theme and take your Charitable Funds journey to the next level.', 'charitable-funds'); ?></p>
                <p ><?php _e('Get Started With Theme By Clicking On Getting Started.', 'charitable-funds'); ?><p>
                <div style="display: flex; justify-content: center; align-items:center; flex-wrap: wrap; gap: 5px">
                    <a class="admin-notice-btn button button-primary button-hero" href="<?php echo esc_url( admin_url( 'themes.php?page=charitable-funds-getting-started' )); ?>"><?php esc_html_e( 'Get started', 'charitable-funds' ) ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="https://demo.asterthemes.com/charitable-funds/"><?php esc_html_e('View Demo', 'charitable-funds') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( CHARITABLE_FUNDS_PREMIUM_PAGE ); ?>"><?php esc_html_e('Buy Now', 'charitable-funds') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( CHARITABLE_FUNDS_BUNDLE_PAGE ); ?>"><?php esc_html_e('Get Bundle', 'charitable-funds') ?></a>
                </div>
            </div>
            <div class="at-admin-image">
                <img style="width: 100%;max-width: 320px;line-height: 40px;display: inline-block;vertical-align: top;border: 2px solid #ddd;border-radius: 4px;" src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/screenshot.png'; ?>" />
            </div>
        </div>
    <?php }
}
add_action( 'admin_notices', 'charitable_funds_deprecated_hook_admin_notice' );


//Admin Notice For Getstart
function charitable_funds_ajax_notice_handler() {
    if ( isset( $_POST['type'] ) ) {
        $type = sanitize_text_field( wp_unslash( $_POST['type'] ) );
        update_option( 'dismissed-' . $type, TRUE );
    }
}